﻿Imports System.Net.Mail
Imports System.Configuration
Imports System.Net
Imports System.Data
Imports System.Threading.Tasks


Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            chklstRecipientesDB.Visible = False
            btnIncluirSelecionado.Visible = False
        End If
    End Sub

    Protected Sub btnEnviar_Click(sender As Object, e As EventArgs) Handles btnEnviar.Click
        Try
            ' se voce quiser enviar emails diretametne do banco de dados
            ' descomente o codigo abaixo e ajuste para enviar 
            '----------------------------------------------------------
            'Dim dsClientes As DataSet = GetDataSetCliente()
            'Dim dtClientes As DataTable = dsClientes.Tables("Clientes")
            'usando Parallel.ForEach
            'Parallel.ForEach(dtClientes.AsEnumerable(), _
            '                 Function(linha)
            '                     Return EnviaEmail(linha("Email").ToString()
            '                 End Function)
            'ou apenas enviando diretamente do BD
            ' ''If dsClientes.Tables("Clientes").Rows.Count > 0 Then
            ''    For Each dr As DataRow In dsClients.Tables("Users").Rows
            ''        EnviaEmail(dr("Email").ToString())
            ''    Next
            ''End If
            '---------------------------------------------------------------

            Dim separador As Char() = {";"c}


            For Each _email As String In txtRecipiente.Text.Split(separador)
                EnviaEmail(_email)
            Next
        Catch ex As Exception
            Server.Transfer("PaginaErro.aspx", True)
        End Try
    End Sub

    Protected Sub btnRecipienteDB_Click(sender As Object, e As EventArgs) Handles btnRecipienteDB.Click
        Try
            Dim dsClientes As DataSet = GetDataSetCliente()

            chklstRecipientesDB.DataSource = dsClientes.Tables(0)
            chklstRecipientesDB.DataTextField = "Email"
            chklstRecipientesDB.DataValueField = "Email"
            chklstRecipientesDB.DataBind()

            chklstRecipientesDB.Visible = True
            btnIncluirSelecionado.Visible = True
        Catch ex As Exception
            Server.Transfer("PaginaErro.aspx", True)
        End Try
    End Sub
    Private Function GetDataSetCliente() As System.Data.DataSet

        Try
            'Para retornar a string de conexao da chave ConnectionString no Web.Config descomente o codigo abaixo
            'Dim connectionString as String = ConfigurationManager.ConnectionStrings("conexaoEmails").ConnectionString
            Dim connectionString As String = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=C:\Dados\Clientes.accdb;Persist Security Info=False;"

            'cria um novo OleDB connection
            Dim conn As New System.Data.OleDb.OleDbConnection(connectionString)

            'passa o comando Select e a informação da conexão para o construtor 
            Dim da As New System.Data.OleDb.OleDbDataAdapter("SELECT Email FROM Emails", conn)

            'Cria um novo datas com a tabela : CLIENTES
            Dim ds As New System.Data.DataSet("Clientes")

            'Preenche o dataset e tabela com os dados retornados
            da.Fill(ds, "Clientes")

            'retorna o novo dataset
            Return ds

        Catch ex As Exception
            Server.Transfer("PaginaErro.aspx", True)
        End Try
    End Function

    Private Sub EnviaEmail(EmailAddress As String)
        Try
            'Envia o email
            Dim mail As New MailMessage()
            'destino
            mail.[To].Add(EmailAddress)
            'origem
            mail.From = New MailAddress("macoratti@yahoo.com")
            'assunto
            mail.Subject = txtAssunto.Text
            'corpo do email (texto)
            mail.Body = txtEmailBody.Text
            'é html ?
            mail.IsBodyHtml = True
            'cria instãncia STMP
            Dim smtp As New SmtpClient()
            'define o servidor SMTP
            smtp.Host = "smtp.gmail.com"
            'Dados do seu servidor SMTP
            smtp.Credentials = New System.Net.NetworkCredential("SeuNomeUsuario@gmail.com", "SuaSenha_gmail")
            'Suas credenciais SMTP
            'habilita o envio via SSL
            smtp.EnableSsl = True
            'envia o email
            smtp.Send(mail)
        Catch ex As Exception
            Server.Transfer("PaginaErro.aspx", True)
        End Try
    End Sub

    Protected Sub btnIncluirSelecionado_Click(sender As Object, e As EventArgs) Handles btnIncluirSelecionado.Click
        Try
            Dim strRecipienteEmails As New StringBuilder()
            For Each chk As ListItem In chklstRecipientesDB.Items
                If chk.Selected Then
                    strRecipienteEmails.Append(chk.Value)
                    strRecipienteEmails.Append(";")
                End If
            Next
            txtRecipiente.Text = strRecipienteEmails.ToString()
            chklstRecipientesDB.Visible = False
            btnIncluirSelecionado.Visible = False

        Catch ex As Exception
            Throw ex
        End Try
    End Sub
End Class